import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { BookingUser, BookingUserParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询
 */
export async function pageBookingUser(params: BookingUserParam) {
  const res = await request.get<ApiResult<PageResult<BookingUser>>>(
    MODULES_API_URL + '/booking/booking-user/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询列表
 */
export async function listBookingUser(params?: BookingUserParam) {
  const res = await request.get<ApiResult<BookingUser[]>>(
    MODULES_API_URL + '/booking/booking-user',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加
 */
export async function addBookingUser(data: BookingUser) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/booking-user',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改
 */
export async function updateBookingUser(data: BookingUser) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/booking-user',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除
 */
export async function removeBookingUser(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/booking-user/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除
 */
export async function removeBatchBookingUser(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/booking-user/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询
 */
export async function getBookingUser(id: number) {
  const res = await request.get<ApiResult<BookingUser>>(
    MODULES_API_URL + '/booking/booking-user/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
